unit FmConvertU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, ExtCtrls, Splitter;

type
  TFormConv = class(TForm)
    Panel1: TPanel;
    ConvBtn: TButton;
    CloseBtn: TButton;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    FileBox: TFileListBox;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    DirBox: TDirectoryListBox;
    Panel4: TPanel;
    DriveBox: TDriveComboBox;
    splitter1: Tsplitter;
    FmCheck: TCheckBox;
    procedure DriveBoxChange(Sender: TObject);
    procedure DirBoxChange(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure FileBoxDblClick(Sender: TObject);
    procedure FmCheckClick(Sender: TObject);
  private
    { Private-Deklarationen }
    bCheck   : boolean;
    FileName : string;
    Function RunConvert(param1 : string; VAR PInfo : DWord) : boolean;
  public
    { Public-Deklarationen }
  end;

var FormConv: TFormConv;

implementation

{$R *.DFM}

procedure TFormConv.DriveBoxChange(Sender: TObject);
begin
  DirBox.Drive := DriveBox.Drive;
end;

procedure TFormConv.DirBoxChange(Sender: TObject);
begin
  FileBox.Directory := DirBox.Directory;
end;

procedure TFormConv.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

Function TFormConv.RunConvert(param1 : string; VAR Pinfo : DWord) : boolean;
VAR lpExitCode : integer;
    StartupInfo: TStartupInfo;
    ProcessInfo: TProcessInformation;
Begin
  FillChar(StartupInfo, SizeOf(TStartupInfo), 0);
  StartUpInfo.cb := SizeOf(tStartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := SW_HIDE;
  if CreateProcess(Nil, pchar(param1), nil, nil, False, NORMAL_PRIORITY_CLASS,
     nil, Nil, StartupInfo, ProcessInfo) then
  Begin
    WaitForSingleObject(ProcessInfo.hProcess, WAIT_ABANDONED);
    GetExitCodeProcess(ProcessInfo.hProcess, PInfo);
    CloseHandle(ProcessInfo.hProcess);
    Result := true;
  end
  ELSE Result := false;
end;

procedure TFormConv.FileBoxDblClick(Sender: TObject);
VAR f       : File;
    OldN    : string;
    Sign    : word;
    DwAkt   : DWord;
    AppDir  : Array[0..255] of char;
begin
  IF FileBox.ItemIndex > -1 THEN
  Begin
    IF NOT bCheck THEN
    Begin
      OldN := FileBox.FileName;
      assignFile(f, OldN);
      reset(f, 1);
      BlockRead(f, Sign, 2);
      CloseFile(f);
      IF Sign = $0AFF THEN
      Begin
        MessageDlg('File: '+OldN+^J+
          'is not nessesary to convert....', MtInformation, [mbOK],0);
        Exit;
      END;
      FileName := ChangeFileExt(OldN, '.txt');
      IF NOT (RenameFile(OldN, FileName)) THEN
      Begin
        MessageDlg('Filname: '+OldN+^J+
          'could not be renamed in '+FileName, mtError,[mbOK],0);
        Exit;
      END
    END ELSE
    Begin
      FileName := FileBox.FileName;
    END;
    Screen.Cursor := crHourGlass;
    IF RunConvert(ExtractFilePath(Application.ExeName)+'convert.exe '+FileName,
         DWAkt) THEN IF DWAkt <> 0 THEN
    FileName := ChangeFileExt(FileName, '.dfm');
    //DwAkt := GetTickCount;
    FileBox.Enabled := false;
    ConvBtn.Enabled := false;
    Screen.Cursor := crDefault;
    IF NOT FileExists(FileName) THEN
    Begin
      Beep;
      MessageDlg('Error acore...... '+^J+
        'converting '+Filename, mtInformation, [mbOK], 0);
    end;
    FileBox.Enabled := true;
    ConvBtn.Enabled := true;
  END;
end;

procedure TFormConv.FmCheckClick(Sender: TObject);
begin
  bCheck := FMCheck.Checked;
  IF bCheck THEN
  Begin
    FMCheck.Caption := 'TXT-Convert';
    FileBox.Mask := '*.txt';
  END
  ELSE Begin
    FMCheck.Caption := 'DFM-Convert';
    FileBox.Mask := '*.dfm';
  END;
  FileBox.Invalidate;
end;

end.
